const NOTIFY_STATE_DOCUMENT =
  Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT; 

var SpurlSideUrl = 'http://www.spurl.net/spurlbar1.php';
var SpurlBaseUrl = 'http://www.spurl.net/spurl.php';
var SpurlPopupOptions = 'width=450,height=550,status=no,resizable=yes,scrollbars=auto';
var idhref, idmiz, index, url, currentURL, node, userid,req,catid;
var old_sidebar_width = top.document.getElementById('sidebar-box').width;
var SpurlPref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('spurlbar.settings.');
// The Global Sidebar Object
var mysidebar;
function getSideBar() {
	if (!mysidebar) {
		mysidebar = top.document.getElementById('sidebar').contentWindow;
	}
	return mysidebar;
}


function LoadSpurl(currentLocation, currentTitle) {
	var browser=getSideBar().document.getElementById("spurlBrowser");
	browser.webNavigation.loadURI(SpurlSideUrl,0,null,null,null);
}


function SideBarClose() {
	top.document.getElementById('sidebar-box').width = old_sidebar_width;
	top.toggleSidebar();
	top.togglespurlbar-button(!spurlbar-button.checked);
}

function clicked (event) {
	// quit if button is not 1 (middle click)
	if (event.button != 1 && !event.ctrlKey) return;
	if (event.button == 1) {
	if (event.target.tagName == "A") {
			if (event.target.href) {
				top.window.openNewTabWith(event.target.href,null,null,true);
			}
		}
		if (event.ctrlKey) SideBarClose ();
		return FALSE;
	}
	if (event.button == 0 && event.ctrlKey) {
		if (event.target.tagName == "A") {
			if (event.target.href) {
				top.window.openNewTabWith(event.target.href,null,null,true);
			}
		}
		return FALSE;
	} else {
		return FALSE;
	}
	

}

// This function is called right when the sidebar is opened
function onLoadSpurlPanel() {
	if (SpurlPref.prefHasUserValue ('spurl_static')) {
		if (SpurlPref.getBoolPref ('spurl_static')) {
			if (SpurlPref.prefHasUserValue ('spurl_width')) {
				var sidebar_width = SpurlPref.getCharPref('spurl_width');
				sidebar_width = sidebar_width.concat('px');
				top.document.getElementById('sidebar-box').width=sidebar_width;
			} else {
				top.document.getElementById('sidebar-box').width="200px";
			}
		}
	}
	LoadSpurl(window.top._content.location.href, window.top._content.document.title);
	if (document.getElementById("spurlContextMenu")){
        document.getElementById("spurlContextMenu").addEventListener("popupshowing",OnPopup,false);
	}
	var SpurlBrowser = document.getElementById("spurlBrowser");
	SpurlBrowser.addProgressListener(nsBrowserStatusHandler,Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
	top.document.getElementById("sidebar-throbber").setAttribute("loading",true);
}

function OnPopup () {
	var item=document.getElementById("hiddenstatus");
	var item_categ=document.getElementById("categories");
	var node = document.popupNode;
    var nodeLocalName = node.localName.toUpperCase();
	idmiz = "";
	catid = "";
	spurlaction.init ();
	if (nodeLocalName === "A" || nodeLocalName === "DIV") {
		if (idmiz != "") {
			item.hidden = false; // Make link options visible
			item_categ.hidden = true;
		} else if (catid != "" && catid != "0") {
			item.hidden = true;
			item_categ.hidden = false;
		} else {
			item.hidden = true;
			item_categ.hidden = true;
		}
	} else {
		item.hidden = true;
		item_categ.hidden = true;
	}
}
/* Handler to track changes in sidebar, so that we can enable throbber */
var nsBrowserStatusHandler = {
	QueryInterface: function(aIID)
   {
      if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
          aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
          aIID.equals(Components.interfaces.nsISupports))
      return this;
      throw Components.results.NS_NOINTERFACE;
   }, 
	onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus) {
		const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;    
		const nsIChannel = Components.interfaces.nsIChannel;
		const STATE_STOP = Components.interfaces.nsIWebProgressListener.STATE_STOP; 
		const STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START; 
		const STATE_IS_WINDOW = Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW; 
		const STATE_IS_REQUEST = Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST; 
		const STATE_IS_NETWORK = Components.interfaces.nsIWebProgressListener.STATE_IS_NETWORK;
        
		if (aStateFlags & STATE_IS_NETWORK && aStateFlags & STATE_START) {
			top.document.getElementById("sidebar-throbber").setAttribute("loading",true);
		}
		if (aStateFlags  == (STATE_IS_WINDOW|STATE_IS_NETWORK|STATE_STOP)) {
			top.document.getElementById("sidebar-throbber").removeAttribute("loading");
			/* Getting the userid by iterating over the document */
			/* Currently not used */
			var SpurlBrowser = document.getElementById("spurlBrowser");
			var node = SpurlBrowser.contentDocument.body;
			var pawn;
			while (node) {
				if (node.hasChildNodes() == true) {
					node = node.firstChild;
				} else { 
					pawn = node;
					if ((node = node.nextSibling) == null) 
					node = pawn.parentNode;
					node = node.nextSibling;
				}
				if (node.nodeType == 8) { 			// comment node
					if ((index = node.nodeValue.indexOf('Userid:')) != -1) {
						userid = node.nodeValue.slice(index+8,-1);
					}
				}
			}
			
		} 
		return 0;
	},
   onLocationChange: function(aProgress, aRequest, aURI)  { return 0; },
   onProgressChange: function() {return 0;},
   onStatusChange: function() {return 0;},
   onSecurityChange: function() {return 0;},
   onLinkIconAvailable: function() {return 0;} 
}
function openPart (part) { 
	if (part == "MySpurls") 
		top.window.loadURI("http://www.spurl.net/myspurls/",null,null,null);
	if (part == "Export") 
		top.window.loadURI("http://www.spurl.net/myspurls/export.php",null,null,null);
	if (part == "Streams")
		top.window.loadURI("http://stream.spurl.net",null,null,null);
	if (part == "Forum")
		top.window.loadURI("http://www.spurl.net/help/forum/",null,null,null);
		
}


var spurlaction = {
	init: function () {
		catid = "";
		node = document.popupNode;
		doc = document.getElementById("spurlBrowser").contentDocument;
		if (node.localName.toUpperCase() != "A" && node.localName.toUpperCase() != "DIV") return;
		currentURL = document.getElementById("spurlBrowser").webNavigation.currentURI;
		if (doc.getElementById('tab_quick').getAttribute("class") == "active"
			|| doc.getElementById('tab_tags').getAttribute("class") == "active") {
				idhref=node.getAttribute("onMouseDown");
				if (idhref == null) return; // do that for 'more...' link
				index = idhref.indexOf('id=')+3;
			} else if (doc.getElementById('tab_my').getAttribute("class") == "active") {
				if (node.id.indexOf("spf-") != -1) { // for categories
					catid = node.id.substring(4); // format of id is id=spf-$id
					return;
				} else {
					catid = 0;
				}
				idmiz=node.id.substring(4);
				return;
			} else {
			idmiz="";
			catid=0;
			return;
		}
		
	},
	modify: function () { 
		url="http://www.spurl.net/myspurls/editspurl.php?id=";
		url = url.concat(idmiz);
		top.window._content.location.href = url;
	},
	copy: function () { 
		url="http://www.spurl.net/myspurls/managespurls.php?action=copy&spurlid=";
		url = url.concat(idmiz);
		top.window._content.location.href = url;
	},
	del: function () { 
		url="http://www.spurl.net/myspurls/managespurls.php?action=delete&spurlid=";
		url = url.concat(idmiz);
		top.window._content.location.href = url;
	},
	intabs: function () {
		opencat.intabs(userid, catid);		
	}
	

}

function OpenCache() {
    var node = document.popupNode;
    var selection = "http://cache.spurl.net/?url=";
    var nodeLocalName = node.localName.toUpperCase();
    
	if (nodeLocalName == "A") {
    	selection = selection.concat(encodeURIComponent(node.href));
    } 
	top.window._content.location.href = selection;
}

function OpenInNewTab() {
    var node = document.popupNode;
    var selection = "";
    var nodeLocalName = node.localName.toUpperCase();
    if (nodeLocalName == "A") {
        selection = node.href;
    } 
	top.window.openNewTabWith(selection,null,null,true);
}

function copyLink () {
        var clipboard = Components.classes['@mozilla.org/widget/clipboardhelper;1'].getService(Components.interfaces.nsIClipboardHelper );
        clipboard.copyString(document.popupNode.href);
}


var spurlURL = {
		withcat: function (remote_url, title, catid) {
			var focusedWindow = document.commandDispatcher.focusedWindow;
		 	var blocked = focusedWindow.getSelection().toString();
		 	var url = SpurlBaseUrl+'?v=4&title=';
			url=url.concat (encodeURIComponent (title));
			var href=remote_url;
			url=url.concat('&url=');
			url=url.concat(encodeURIComponent(href));
			url=url.concat('&cat='+catid);
			url=url.concat('&blocked=');
			url=url.concat(encodeURIComponent(blocked));
			window.open(url,'_blank', SpurlPopupOptions);
		},
		withtag: function (remote_url, title, tag) {
			var focusedWindow = document.commandDispatcher.focusedWindow;
		 	var blocked = focusedWindow.getSelection().toString();
		 	var url = SpurlBaseUrl+'?v=4&title=';
			url=url.concat (encodeURIComponent (title));
			var href=remote_url;
			url=url.concat('&url=');
			url=url.concat(encodeURIComponent(href));
			url=url.concat('&tags=');
			url=url.concat(encodeURIComponent(tag));
			url=url.concat('&blocked=');
			url=url.concat(encodeURIComponent(blocked));
			window.open(url,'_blank',SpurlPopupOptions);
		}
}

var dragObserver = {
	getSupportedFlavours: function () {
		var flavours = new FlavourSet ();
		flavours.appendFlavour("text/x-moz-url");
		return flavours;
	},
	onDragOver: function(evt,flavour,session) {},
	onDrop: function (evt,dropdata,session) {
		if (dropdata == "") return;

		var url;
		var title;
		var urlTitleArr = dropdata.data.split("\n");
		if (urlTitleArr.length == 2) {
			url = urlTitleArr[0];
			title = urlTitleArr[1];
		} else {
			url = urlTitleArr[0];
			title = '';
		}
		if (evt.target.href != null) {
			index = evt.target.href.indexOf('selcat=')+7;
			if (index == 6) catid = 0; else	   // if it can't find text
			catid = evt.target.href.substring(index);
		} else {
			catid = 0;
		}
		if (catid == 0) {
			var onClick = evt.target.getAttribute('onclick');
			try {
				index = onClick.indexOf('clicktag')+10;
			} catch (e) {
			    index = 9
			};
			if (index == 9) tag = ""; else
			{
				lastindex = onClick.indexOf(';')-2;
				tag = onClick.substring(index,lastindex);
			};
			spurlURL.withtag (url,title,decodeURIComponent(tag));
		}  else 
			spurlURL.withcat (url,title,catid);
	}	
}
/*
var getData = {
	start: function (uid,catid) {
	var url = "http://www.spurl.net/myspurls/quick_links.php?p=rss&l=most&userid="+uid+"&language=en&filter=1";
	req = new XMLHttpRequest ();
	req.onreadystatechange = this.process;
	req.open ("GET", url,true);
	req.send (null);
	},
	process: function () {
		if (req.readyState == 4) {
			if (req.status == 200) {
			   alert(req.responseXML.getElementsByTagName("link").item(1).firstChild.nodeValue);
			 }
		}
	}
}
*/			   
/* Not used currently*/
var opencat = {
	intabs: function (uid,catid) {
		var xmlurl = 'http://www.spurl.net/myspurls/library.php?p=rss&userid='+uid.substring(-1)+'&c='+catid;
		req = new XMLHttpRequest();
		req.onreadystatechange = this.processtab;
		req.open ("GET",xmlurl,true);
		req.send (null);
	},
	processtab: function () {
		if (req.readyState == 4) {
			if (req.status == 200) {
				var items = req.responseXML.getElementsByTagName("link");
				for (var i=2; i < items.length; i++) {
					href = items[i].firstChild.nodeValue;
					top.window.openNewTabWith(href,null,null,true);
				}
			}  else {
				alert ("error happened");
			}
		}
	}
}
